<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>OrderedExecutionExchange.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.exchanges.executor</a> &gt; <span class="el_source">OrderedExecutionExchange.java</span></div><h1>OrderedExecutionExchange.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.exchanges.executor;

import io.gitlab.littlesaints.protean.Constants;
import io.gitlab.littlesaints.protean.configuration.Config;
import io.gitlab.littlesaints.protean.exchanges.MessageExchange;
import io.gitlab.littlesaints.protean.resources.Registrar;

/**
 * This executor performs ordered executions.
 * The order of execution for submitted objects is determined by a orderResolver. This orderResolver is provided during the instantiation of this executor.
 *
 * @author Varun Anand
 * @since 1.0
 */
<span class="nc" id="L35">public abstract class OrderedExecutionExchange {</span>

	public static final String TYPE = &quot;protean::exchange::execution::ordered&quot;;

<span class="fc" id="L39">	public static class _Registrar implements Registrar {</span>
		static {
<span class="fc" id="L41">			MessageExchange.REGISTRY.register(TYPE, OrderedExecutionExchange::newInstance);</span>
<span class="fc" id="L42">		}</span>

		@Override
		public String toString() {
<span class="fc" id="L46">			return &quot;OrderedExecutionExchange::Registrar&quot;;</span>
		}
	}

	private static &lt;E&gt; MessageExchange&lt;E&gt; newInstance(final int capacity, final boolean isMultiProducer, final Config config) {
		final MessageExchange&lt;E&gt; executionExchange;
<span class="fc bfc" id="L52" title="All 2 branches covered.">		if (isMultiProducer) {</span>
<span class="fc" id="L53">			executionExchange = new OrderedExecutionMultiExchange&lt;&gt;(config.getOrDefault(Constants.NAME, System.currentTimeMillis() + &quot;OEME&quot;), config.&lt;Integer&gt;getOrDefault(Constants.CONCURRENCY, Runtime.getRuntime().availableProcessors()), capacity,</span>
<span class="fc" id="L54">				config.get(Constants.Exchange.EXCHANGE_SUPPLIER), config.get(Constants.Exchange.PROCESSOR_SUPPLIER), config.get(Constants.Exchange.ORDER_RESOLVER), config.getOrDefault(&quot;lazyRoutes&quot;, true));</span>
		} else {
<span class="fc" id="L56">			executionExchange = new OrderedExecutionSingleExchange&lt;&gt;(config.getOrDefault(Constants.NAME, System.currentTimeMillis() + &quot;OESE&quot;), config.&lt;Integer&gt;getOrDefault(Constants.CONCURRENCY, Runtime.getRuntime().availableProcessors()), capacity,</span>
<span class="fc" id="L57">				config.get(Constants.Exchange.EXCHANGE_SUPPLIER), config.get(Constants.Exchange.PROCESSOR_SUPPLIER), config.get(Constants.Exchange.ORDER_RESOLVER));</span>
		}
<span class="fc" id="L59">		return executionExchange;</span>
	}

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>